﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.IO;
using System.Management;
using Microsoft.VisualBasic;

namespace GET_CALCULATION_FAN_ALONE_PC
{
    public partial class Form1 : Form
    {  
        #region DLLImports*********************************************
       [DllImport(@"EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)] // Import a function from the DLL data EbmPapstFan.dll to this programm with the characterset Ansi   // Importiere eine Funktion von der DLL Datei EbmPapstFan.dll zu diesem Programm mit dem Zeichensatz Ansi
        public static extern int SET_XML_PATH_PC([MarshalAsAttribute(UnmanagedType.AnsiBStr)]string pfad);        // The programm can use the function GetDLLVersion      // Das Programm kann nun diese Funtion benutzen
                                                                      //ref allows to modify the contents of variables that's passed to the DLL       

       [DllImport(@"EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
       public static extern int GET_PRODUCTS_PC([MarshalAsAttribute(UnmanagedType.AnsiBStr)]ref string pfad);
       

       [DllImport(@"EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
       public static extern int GET_CALCULATION_FAN_ALONE_PC([MarshalAsAttribute(UnmanagedType.AnsiBStr)]string fanDescription, ref string buffer);
       #endregion
       public Form1()
        {
            InitializeComponent();
        }
        #region btpfad_Click*******************************************
        private void btpfad_Click(object sender, EventArgs e)
        {
            string BuPath;                                                                                     // Declaration of the String BuPath // Deklaration des strings BuPath
            FolderBrowserDialog folderBrowserDialog1 = new FolderBrowserDialog();                              // Creation of the FolderBrowserDialog where you can choose the path // FolderBrowser wird erstellt, wo man den Pfad wählen kann
            if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)                                          // If you click "Ok" on the BrowserDialog // Wenn "Ok" auf dem FolderBrowserDialog geklickt wird
            {
                BuPath = folderBrowserDialog1.SelectedPath;                                                    // Save the path in the variable BuPath // Speichere den Pfad in die Variable BuPath
                DialogResult dialogResult = MessageBox.Show("Wollen sie den Pfad " + BuPath + " übernehmen?", "Pfad übernehmen?", MessageBoxButtons.YesNo); // Message Box appears which asks you whether you want to take the path // Benachrichtigung erscheint welche dich frägt, ob du den Pfad übernehmen möchtest 
                if (dialogResult == DialogResult.Yes)       // If yes is clicked // Wenn Ja gecklickt wurde
                {
                    tbPfad.Text = BuPath;                   // Textbox shows the Path // Die Textbox zeigt den Pfad an
                }
                else if (dialogResult == DialogResult.No)   // If no is clicked // Wenn Nein geklickt wurde
                {
                    MessageBox.Show("Die Verarbeitung wurde abgebrochen"); // Message appears with the content that the processing is stopped // Verarbeitung wird abgebrochen und über eine Benachrichtigung bekanntgegeben
                }
            }           
        }
        #endregion
        #region btPath_TO_DATABASE_Click*******************************
        private void btPATH_TO_DATABASE_Click(object sender, EventArgs e)
        {
            Int32 n;                                                        // Deklaration of the variable n // Deklaration der Variable n
            string path;                                                    // Deklaration of the variable path // Deklaration der Variable path

            path = tbPfad.Text;                                             // Save the content of the Textbox(the path) in the varaible path // Speichere den Inhalt der Textbox(den Pfad) in die Variable path          

            n = setPath(path);                                              // Look after the path, whet // Schaue nach dem Pfad

            if (Directory.Exists(path) == false)                            // If Path doesn´t exists.. // Wenn der Pfad nicht existiert..
            {
                MessageBox.Show("Pfad existiert nicht! Bitte wählen sie einen gültigen Pfad."); // ..Show a Message that the path doesn´t exists // .. Zeige eine Benachrichtigung, dass der Pfad nicht existiert
            }
        }
        #endregion
        #region setPath************************************************
        private int setPath(string path)
        {
            Int32 n;                                   // Declaration of the variable n for the error code // Deklaration der Variable n für den Error Code
            Int32 l;                                   // Declaration of the variable l for the length of the path (the number of the used signs)     // Deklaration der Variable l für die Länge des Pfades (die Anzahl der verwendete Zeichen)
                                          

            if (File.Exists(path + @"\Data.sqlite"))   // If the File Data.sqlite exists in the path // Wenn die File Data.sqlite im Pfad existiert 
            {
                l = path.Length;                       // Get the lentgh of the string path and save it // die Länge des strings path wird gespeichert 


                if (path[l - 1] != (';'))              // If there is no semicolon at the end of the Path // Wenn am Ende des Pfades kein Semikolon steht
                {
                    path = path + (';');               // Write a semicolon for the function SET_XML_PATH_PC // Füge ein Semikolon hinzu für die Funktion SET_XML_PATH_PC
                    n = SET_XML_PATH_PC(path);         // Get the Error Code 0 = the database is available; -1 = the database isn´t available // Hole den Errorcode aus der Funktion 0 = Datenbank ist verfügbar -1 = Datanbank ist nicht verfügbar 
                    show_Results(n, path);             // Show the result // Zeige das Ergebnis
                }
            }
            n = -1;                                     
            return n;
        }
        #endregion
        #region show_Results*******************************************
        public void show_Results(int n, string path)
        {
            int l;                                     // Declaration of the variable l for the length of the string // Deklaration der Variable l für die Länge des Strings
            l = path.Length;                           // Get the length and save it in the variable l // Hole die Länge und speichere sie in der variable l
            if (path[l - 1] == ';')                    // If the last sign in the string is a semicolon.. // Wenn das letze Zeichen im string Pfad ein Semikolon ist.. 
            {
                path = path.Remove(l - 1, 1);          //.. Delete it // ..Lösche es
                if (File.Exists(path + @"\Data.sqlite") == true)  // If the File Data.sqlite exists in the path // Wenn die File Data.sqlite im Pfad existiert  
                {
                    tbPfad.Text = path;                // Write the path in the textbox // schreibe den Pfad in die Textbox
                    tbErrorcode.Text = Convert.ToString(n); // show the Error Code
                }
                else                                   // If the File Data.sqlite doesn´t exist in the path // Wenn die File Data.sqlite nicht im Pfad existiert  
                {
                    tbErrorcode.Text = "-1";           // Write the errorcode -1 in the textbox (Database isn´t available)     
                    tbPfad.Text = "keine Datenbankk vorhanden!" + path + @"\Data.sqlite"; // The Textbox shows the message that the database is not available // Die Textbox zeigt die Nachricht, das die Datenbank nicht vorhanden ist
                }
            }
        }
        #endregion

        #region btGetProductsPC_Click**********************************
        private void btGetProductsPC_Click(object sender, EventArgs e)
        {
            List_Item('P');                                                     // List the Items (ID and Type) in the listbox and the groupboxes // Liste die Items(ID und Typ) der Listbox und der Groupboxen auf
        }
        #endregion
        #region list_item**********************************************
        private void List_Item(char mode)
        {
                        
            int n;                                                              // Declaration of the variable n for the number of products // Deklaration der Variable n für die Anzahl der Produkte    
            string fanStringChar = new string(new Char(), 4000);                // Declaration of the variable fanStringChar for the function GET_PRODUCTS_PC // Deklaration der Variable fanStringChar für die Funktion GET_PRODUCTS_PC
                        
            GC.GetTotalMemory(false);                                           // Free the Memory // Leere den Speicher
            GC.GetTotalMemory(true);                                            // reserve Memory for the function // Reserviere Speicher für die Funktion 

            Clear_Display();                                                    // Delete the Information in the listbox and the comboboxes // Lösche die Informationen in der listbox und der Comboboxen
            
            n = GET_PRODUCTS_PC(ref fanStringChar);                             // Get the Products n = the number of Products // Hole die Produkte  n = Die anzahl der Produkte bzw Ventilatoren 
            if (n < 0)                                                          // If the number is negative (because u didn´t Set the Path).. // Wenn die Anzahl negativ ist (Weil der Pfad noch nicht gesetzt wurde)
            {
                MessageBox.Show("Der Pfad wurde noch nicht gesetzt!");          // Show a Message that the path wasn´t set // Zeige eine Benachrichtigung, dass der Pfad nicht gesetzt wurde
            }
            else
            {
                show_Results_2(n, fanStringChar);                            // Show the result in the list box and the Comboboxes // Zeige das Ergebnis in der Listbox und den Comboboxen           
            }
        }
        #endregion
        #region Clear_Display******************************************
        private void Clear_Display()
        {
            lbInfo.Items.Clear();                                               // Delete the information in the listbox // Lösche die Informationen in der listbox
            comBoxIdNo.Items.Clear();                                           // Delete the Information (Product ID) in the Combobox // Lösche die Informationen (Product ID) in der Combobox
            comBoxTyp.Items.Clear();                                            // Delete the information (Type) in the Combobox // Lösche die Informationen (Typ) in der Combobox 
        }
        #endregion
        #region show_Results_2*****************************************
        private void show_Results_2(int n, string FanList) // Function with the parameters: n = number of products; FanList = All the Information(Product ID and Type) of the ventilators // Funktion mit den Parametern : n = Anzahl der Produkte; FanList =  Alle Informationen(Product ID und Typ) zu den Ventilatoren 
        {
                      
            string[] Typen = new string[n+1];                                 // Declaration of a string array for the types // Deklaration eines string Arrays für die Typen

            string[] IdNo = new string[n+1];                                  // Declaration of a string array for the ID // Deklaration eines string Arrays für die ID
                                          
            int m;                                                              // Declaration of the variable m for the number of signs after a '|' // Deklaration der Variable m für die Anzahl der Zeichen nach einem '|'                                                              
            string temp = "";                                                   // Declaration of the variable temp for transporting the product information into the arrays // Deklaration der Variable temp um die Produktinformationen in die Arrays zu transportieren
            int j = 0;                                                          // Declaration of the variable j for the Index of the Arrays // Deklaration der Variable j für den Index der Arrays
            int k;                                                              // Declaration of the variable k for the index of the Array destination // Deklaration der Variable k für den Index des Arrays destination
            tbGetFan.Text = Convert.ToString(n);                                // Write in the second Errorcode textbox the number of ventilators // Schreibe in der zweiten Errorcode Textbox die Anzahl der Ventilatoren 
                                                                   
            char[] thecopy = new char[FanList.Length];                      // Declaration of the Array thecopy for copying the product information  // Deklaration des Arrays thecopy,um die Produktinformationen zu kopieren  
                           
            FanList = FanList.Replace(';', '|');                            // Replace all semicolons in the string with '|' // Ersetze alle Semikolons in dem string durch '|'
                       
            lbInfo.Items.Add("number of existing ventilators:" + Convert.ToString(n));  // Listbox shows the number of ventilators // Die Listbox zeigt die Anzahl der Ventilatoren an


            n = 1;                                                          // Set n = 1 for showing all products (if n = 0 one product is missing)// setze n auf "1" um alle Produkte zu zeigen (bei n = 0 würde eins fehlen)
            while (FanList.Length > 0)                                      // While the Length of the String is bigger than 0 .. // Während die Länge des Strings größer als 0 ist..
            {
                m = FanList.IndexOf('|');                                   // ..set the number of signs till a '|' was found // .. setze die Anzahl der Zeichen bis ein '|' gefunden wurde
                for (k = 0; k < 50; k++)                                    // .. delete the values in the array // .. lösche die Werte in dem Array
                {
                    thecopy[k] = '\0';
                }
                FanList.CopyTo(0, thecopy, 0, m);                           // copy the ID to the char Array and save it in the string temp // Kopiere die ID in das char Array und speichere es in dem string temp 
                while (true)
                {
                    if (thecopy[j] == '\0')
                    {
                        break;
                    }
                    else
                    {
                        temp = temp + thecopy[j];
                        j++;                                                // increment j as long as a '\0' sign appears // inkrementiere solange bis ein '\0' Zeichen erscheint 
                    }
                }
                IdNo[n] = temp;                                             // copy the ID to the string Array IdNo // kopiere die ID in das string Array IdNo
                FanList = FanList.Remove(0, m + 1);                         // delete the ID in the string .. the Length is reduced now // Lösche die ID in dem string .. die Länge ist nun reduziert                                                           
                temp = "";                                                  // delete the content of temp // Lösche den Inhalt von temp             
                j = 0;                                                      // set j to 0 to count from the beginning // setze j auf 0 um vom Anfang hochzuzählen
                m = FanList.IndexOf('|');                                   // set the number of signs till a '|' was found // .. setze die Anzahl der Zeichen bis ein '|' gefunden wurde
                for (k = 0; k < 50; k++)
                {
                    thecopy[k] = '\0';
                }
                FanList.CopyTo(0, thecopy, 0, m);                           //  Copy the Type to the char Array and save it in the string temp // Kopiere den Typ in das char Array und speichere es in dem string temp
                while (true)
                {
                    if (thecopy[j] == '\0')
                    {
                        break;
                    }
                    else
                    {
                        temp = temp + thecopy[j];
                        j++;                                               // Increment j as long as a '\0' sign appears // Inkrementiere solange bis ein '\0' Zeichen erscheint  
                    }
                }
                Typen[n] = temp;                                             // Copy the ID to the string Array IdNo // Kopiere die ID in das string Array IdNo
                FanList = FanList.Remove(0, m + 1);                          // Delete the ID in the string .. the Length is reduced now // Lösche die ID in dem string .. die Länge ist nun reduziert                                                           
                temp = "";                                                  // Delete the content of temp // Lösche den Inhalt von temp             
                j = 0;                                                      // Set j to 0 to count from the beginning // Setze j auf 0 um vom Anfang hochzuzählen
               
               
                lbInfo.Items.Add("No:  " + Convert.ToString(n) + "  " + IdNo[n] + "  " + Typen[n]); // Show the product information of one product in the listbox // Zeige die Produktinformation eines Produktes in der Listbox
                comBoxIdNo.Items.Add(IdNo[n]);                                                      // Show the ID of one product in the listbox // Zeige die ID eines Produktes in der Combobox                                                      
                comBoxTyp.Items.Add(Typen[n]);                                                      // Show the Type of one product in the listbox // Zeige den Typ eines Produktes in der Combobox 
                n++;                                                                                // increment n to show all products // inkrementiere n um alles Produkte anzuzeigen

            }
            comBoxIdNo.Text = IdNo[1];                                                              // Show the ID of the first product in the Combobox // Zeige die ID des ersten Produkts in der Combobox 
            comBoxTyp.Text = Typen[1];                                                              // Show the Type of the first product in the Combobox // Zeige den Typ des ersten Produkts in der Combobox
        }
        #endregion
        #region Events*************************************************
        private void comboBoxIdNo_SelectedIndexChanged(object sender, EventArgs e)
        {
            //Changes automatically the value in the text box if the product ID combo box value is changed // Ändert automatisch den Wert in der Textbox, wenn der Wert der product ID combobox sich ändert
            tbIdNo_1.Text = comBoxIdNo.SelectedItem.ToString();
            comBoxTyp.SelectedIndex = comBoxIdNo.SelectedIndex;
            lbInfo.SelectedIndex = comBoxIdNo.SelectedIndex + 1;
        }

        private void comboBoxType_SelectedIndexChanged(object sender, EventArgs e)
        {
            // Changes automatically the selected index of the listbox and the ID combo boxx if the value is changed // Ändert automatisch den ausgewählten Index der Listbox und der ID Combobox, wenn sich der Wert ändert 
            comBoxIdNo.SelectedIndex = comBoxTyp.SelectedIndex;
            lbInfo.SelectedIndex = comBoxTyp.SelectedIndex + 1;
        }

        private void listBoxProducts_SelectedIndexChanged(object sender, EventArgs e)
        {
            // Changes automatically the selected index of the type combo box and the ID combo box if the value is changed // Ändert automatisch den ausgewählten Index der type Combobox und der ID Combobox, wenn sich der Wert ändert
            if (lbInfo.SelectedIndex != 0 && lbInfo.SelectedIndex != 1)
            {
                comBoxIdNo.SelectedIndex = lbInfo.SelectedIndex - 1;
                comBoxTyp.SelectedIndex = lbInfo.SelectedIndex - 1;
            }
        }
        #endregion
        #region btGET_CALCULATION_FAN_ALONE_PC_Click*******************
        private void btGET_CALCULATION_FAN_ALONE_PC_Click(object sender, EventArgs e)
        {
                                                             
            string buffer = new string(new Char(), 4000);                               // Declaration of the variable buffer with a size of 4000 signs for the function // Deklaration der Variable buffer mit der Größe von 4000 Zeichen für die Funktion
            string Input_Data = "";                                                     // Declaration of the variable Input_Data for the product values // Deklaration der Variable Input_Data für die Produktwerte
            int n;                                                                      // Declaration of the variable n for the function // Deklaration der Variable n für die Funktion
            Input_Data = Get_Input_Value(Input_Data);                                   // Get the Input Values // Hole die Input Werte
            
            GC.GetTotalMemory(false);                                                   // Free the Memory for the function // setze Speicher frei für die Funktion
            GC.GetTotalMemory(true);                                                    // Get Memory for the function // Hole Speicher für die Funktion
            n = GET_CALCULATION_FAN_ALONE_PC(Input_Data, ref buffer);                   // Fill the empty values // fülle die leeren Werte
            show_Results_GET_CALCULATION_FAN_ALONE(n,buffer);                           // Show the results in the text boxes, comboboxes and listboxes // Zeige das Ergebnis in den Textboxen, Comboboxen und listboxen an

        }
        #endregion
        #region Get_Input_Value****************************************
        private string Get_Input_Value(string Input_Data)
        {
            double Volumenstrom = Convert.ToDouble(tb_VpktSoll.Text) / 3600;            // Get the Air volume and put it into Input Data 
            Input_Data = comBoxIdNo.Text + ';' + // the ID // die ID                    // Put all the information into the string and fill it with semikolons for other information  // Setze alle Informationen in den String und fülle es mit Semikolon um weitere Informationen zu bekommen
                         ComboBoxt_Druck_stat_tot.Text + ';' +                          // 0 = static Pressure 1 = total pressure//0=statischer Druck; 1=total Druck
                         ComboBox_Inst_typ.Text + ';' +                                 // InstallationType(0:DIDO,1:FIDO,2:DIFO,3:FIFO) //InstallationTyp(0:DIDO,1:FIDO,2:DIFO,3:FIFO)
                         tbRoh0.Text + ';' +                                            // AirDensity(kg/m³) // {Luftdichte(kg/m³)
                         tb_Hoehe.Text + ';' +                                          // The altitude // Höhe über NN 
                         tb_T0.Text + ';' +                                             // AirTemperature(°C) // Lufttemperatur(°C)
                         tb_PfaSoll.Text + ';' +                                        // requiredPressure(Pa) // Druck des vorgegebenen AP 
                         Convert.ToString(Volumenstrom) + ';' +                         // flowRate(m³/h) // Volumenstrom des vorgegebenen AP 
                         tb_U.Text + ';';                                               // Voltage (U) // Spannung U
            lb_GET_CALCULATION_FAN_ALONE.Items.Clear();                                 // Clear the listbox 
            lb_GET_CALCULATION_FAN_ALONE.Items.Add("fanDescription=" + Input_Data);     // Here you can see the first Information that is saved  // Dort kann man die erste Informationen sehen die gespeichert wurden
            return Input_Data;
        }
        #endregion
        #region show_Results_GET_CALCULATION_FAN_ALONE*****************
        private void show_Results_GET_CALCULATION_FAN_ALONE(int n, string buffer)
        {

            string[] Descripts = new string[4000];                                      // Declaration of the string array Descripts for saving the values // Deklaration des string Arrays zum Speichern der Werte                                 
            string[] theText = new string[50];
            theText[0] = " \t (n [1/min])";
            theText[1] = " \t (Pe [W])";
            theText[2] = " \t (I [A])";
            theText[3] = " \t (ηe [%])";
            theText[4] = " \t (U control [V])";
            theText[5] = " \t (Md [Ncm])";
            theText[6] = " \t (ηo [%])";
            theText[7] = " \t (LwA(in+out)[dBA])";
            theText[8] = " \t (LwA(in))[dBA]";
            theText[9] = " \t (LwA(out)[dBA]";
            theText[10] = " \t (Lw_62.5_Hz (in) [dB])";
            theText[11] = " \t (Lw_125__Hz (in) [dB])";
            theText[12] = " \t (Lw_250__Hz (in) [dB])";
            theText[13] = " \t (Lw_500__Hz (in) [dB])";
            theText[14] = " \t (Lw_1000_Hz (in) [dB])";
            theText[15] = " \t (Lw_2000_Hz (in) [dB])";
            theText[16] = " \t (Lw_4000_Hz (in) [dB])";
            theText[17] = " \t (Lw_8000_Hz (in) [dB])";
            theText[18] = " \t (Lw_62.5_Hz (out) [dB])";
            theText[19] = " \t (Lw_125__Hz (out) [dB])";
            theText[20] = " \t (Lw_250__Hz (out) [dB])";
            theText[21] = " \t (Lw_500__Hz (out) [dB])";
            theText[22] = " \t (Lw_1000_Hz (out) [dB])";
            theText[23] = " \t (Lw_2000_Hz (out) [dB])";
            theText[24] = " \t (Lw_4000_Hz (out) [dB])";
            theText[25] = " \t (Lw_8000_Hz (out) [dB])";
            theText[26] = " \t (pf[Pa])";
            theText[27] = " \t (psf[Pa])";
            theText[28] = " \t (qv [m³/h])";

            string tmpDescript;                                                         // Declaration of the variable tmpDescript for copying the values into the array // Deklaration der Variable tmpDescript um die Werte in das Array rein zu kopieren
            int m = 0;                                                                  // m: number of signs till the next semikolon was found // m: Anzahl der Zeichen bis das nächste Semikolon gefunden wurde 
            int k;                                                                      // k: counter variable to delete the information of the char array fandescription // K: Zählvariable um die Information zu löschen die in dem char Array fandescription steht
            int j = 0;                                                                  // j: counter variable to fill the information into the string tmpDescript // j: counter variable um die Information in dem string tmp Descript zu füllen 
            int zahl = 0;                                                               // zahl: countervariable for the array Descripts // zahl: Zählvariable für das string Array Descripts
            lb_mListe.Items.Clear();                                                    // Delete the Information in the list // Lösche die Informationen in der Liste 
            tbIdNo_1.Text = comBoxIdNo.Text;                                            // Copy the ID from the combobox into the ID textbox // Kopiere die ID von der Combobox in die ID Textbox  
            tmpDescript = "";                                                           
            char[] fandescription = new char[4000];                                     // Declaration of the char Array fandescription to get the information from the string buffer // Deklaration des char Arrays fandescription um die Information vom string zu bekommen

            while (buffer.Length > 0)
            {
                m = buffer.IndexOf(';');                                                // Get the number of signs till the next semikolon was found // Hole die Anzahl der Zeichen bis das nächste Semikolon gefunden wurde
                for (k = 0; k < 50; k++)
                {
                    fandescription[k] = '\0';                                           // Delete the information // Lösche die Information
                }
                buffer.CopyTo(0, fandescription, 0, m);                                 // Copy one Information into the char array // Kopiere eine Information in das char Array
                while (true)
                {
                    if (fandescription[j] == '\0')                                      // If there is still information(signs) copy it to the string tmp Descript // Wenn immer noch informationen(signs) vorhanden sind, dann füge sie dem string tmpDescript hinzu  
                    {
                        break;
                    }
                    else
                    {
                        tmpDescript = tmpDescript + fandescription[j];

                    }
                    j++;
                }
                buffer = buffer.Remove(0, m + 1);                                       // Delete the Information in the string buffer because it will be saved and shortens the Length of buffer // Lösche die Information in dem string buffer weil sie gespeichert wird sind und die Länge von buffer verkürzt               
                lb_mListe.Items.Add(tmpDescript + theText[zahl]);                                       // Add this Information to the list // Füge die Information der Liste hinzu
                Descripts[zahl] = tmpDescript;                                          // Save the Information in the array // Speicher die Information im Array
                tmpDescript = "";                                                       // Delete the Information in tmpDescript to get a new Information // Lösche die Information im tmpDescript um eine neue Information zu holen
                zahl++;
                j = 0;                                                                  // j = 0 because you have to count from the beginning // j = 0 weil man vom Anfangswert beginnen muss
            }

            // Write the Information in the textboxes // Schreibe die Informationen in die Textboxen
            tb_ErrCode_GET_CALCULATION_FAN_ALONE.Text = Convert.ToString(n);            // 
            tb_PfaSoll_.Text = tb_PfaSoll.Text;                                         //
            tb_VpktSoll_.Text = tb_VpktSoll.Text;                                       //

            tb_nSoll.Text = Descripts[0];                                               //
            tb_P1Soll.Text = Descripts[1];                                              //
            tb_ISoll.Text = Descripts[2];                                               //
            tb_EtaSoll.Text = Descripts[3];                                             //
            tb_UstSoll.Text = Descripts[4];                                             //
            tb_MdSoll.Text = Descripts[5];                                              //
            tb_EtaMSoll.Text = Descripts[6];                                            //
            tb_LwASoll.Text = Descripts[7];                                             //
            tb_LwAssSoll.Text = Descripts[8];                                           //
            tb_LwAdsSoll.Text = Descripts[9];                                           //

            tb_Lwss62_5_Soll.Text = Descripts[10];                                      //
            tb_Lwss125_Soll.Text = Descripts[11];                                       //
            tb_Lwss250_Soll.Text = Descripts[12];                                       //
            tb_Lwss500_Soll.Text = Descripts[13];                                       //
            tb_Lwss1000_Soll.Text = Descripts[14];                                      //
            tb_Lwss2000_Soll.Text = Descripts[15];                                      //
            tb_Lwss4000_Soll.Text = Descripts[16];                                      //
            tb_Lwss8000_Soll.Text = Descripts[17];                                      //

            tb_Lwds62_5_Soll.Text = Descripts[18];                                      //
            tb_Lwds125_Soll.Text = Descripts[19];                                       //
            tb_Lwds250_Soll.Text = Descripts[20];                                       //
            tb_Lwds500_Soll.Text = Descripts[21];                                       //
            tb_Lwds1000_Soll.Text = Descripts[22];                                      //
            tb_Lwds2000_Soll.Text = Descripts[23];                                      //
            tb_Lwds4000_Soll.Text = Descripts[24];                                      //
            tb_Lwds8000_Soll.Text = Descripts[25];                                      //
            tb_PtotSoll.Text = Descripts[26];                                           //
        }
        #endregion

        private async void timer1_Tick(object sender, EventArgs e)
        {
            timer1.Enabled = false;
            String[] parms = Environment.GetCommandLineArgs();
            int n;




            try
            {
                string path = parms[1];
                tbPfad.Text = path;
                path = parms[1] + (';');
                n = SET_XML_PATH_PC(path);         // Get the Error Code 0 = the database is available; -1 = the database isn´t available // Hole den Errorcode aus der Funktion 0 = Datenbank ist verfügbar -1 = Datanbank ist nicht verfügbar 
                show_Results(n, path);             // Show the result // Zeige das Ergebnis


                await PutTaskDelay();
                List_Item('P');
                await PutTaskDelay();
                btGET_CALCULATION_FAN_ALONE_PC_Click(sender,e);

            }
            catch (Exception ex)
            {

            }
        }

        async Task PutTaskDelay()
        {

            await Task.Delay(1000);
        }


    }
}
       
    

