﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.IO;
using System.Management;
using Microsoft.VisualBasic;

namespace POLYNOM
{
    public partial class Form1 : Form
    {
        #region globale Variablen*********************************************
        string parameter = "";
        string errCode = "";
        string errMessage = "";
        int l;
        int n = -1;
        StringBuilder sbInputData = new StringBuilder();
        Button clickedButtonGlobal = new Button();
        #endregion

        #region DLLImports*****************************************************
        [DllImport(@"EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)] // Import a function from the DLL data EbmPapstFan.dll to this programm with the characterset Ansi   // Importiere eine Funktion von der DLL Datei EbmPapstFan.dll zu diesem Programm mit dem Zeichensatz Ansi
        public static extern int SET_XML_PATH_PC([MarshalAsAttribute(UnmanagedType.AnsiBStr)]string pfad);        // The programm can use the function GetDLLVersion      // Das Programm kann nun diese Funtion benutzen
        //ref allows to modify the contents of variables that's passed to the DLL


        [DllImport(@"EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public static extern int GET_PRODUCTS_PC([MarshalAsAttribute(UnmanagedType.AnsiBStr)]ref string pfad);

        //GET_GRAPH_PC
        //Pay attention to the DLL-function's parameters if there is a "var" in front of a parameter like fanDescription.
        //_ If there is a "var", then in most cases you should use "ref" in the declaration here.
        [DllImport(@"EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public static extern int GET_GRAPH_PFA_PC([MarshalAsAttribute(UnmanagedType.AnsiBStr)]string fanDescription, ref string buffer);

        [DllImport(@"EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public static extern int GET_GRAPH_N_PC([MarshalAsAttribute(UnmanagedType.AnsiBStr)]string fanDescription, ref string buffer);

        [DllImport(@"EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public static extern int GET_GRAPH_PT_PC([MarshalAsAttribute(UnmanagedType.AnsiBStr)]string fanDescription, ref string buffer);

        [DllImport(@"EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public static extern int GET_GRAPH_ETA_PC([MarshalAsAttribute(UnmanagedType.AnsiBStr)]string fanDescription, ref string buffer);

        [DllImport(@"EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public static extern int GET_GRAPH_POWER_PC([MarshalAsAttribute(UnmanagedType.AnsiBStr)]string fanDescription, ref string buffer);

        [DllImport(@"EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public static extern int GET_GRAPH_I_PC([MarshalAsAttribute(UnmanagedType.AnsiBStr)]string fanDescription, ref string buffer);

        [DllImport(@"EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public static extern int GET_GRAPH_MD_PC([MarshalAsAttribute(UnmanagedType.AnsiBStr)]string fanDescription, ref string buffer);

        [DllImport(@"EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public static extern int GET_GRAPH_META_PC([MarshalAsAttribute(UnmanagedType.AnsiBStr)]string fanDescription, ref string buffer);

        [DllImport(@"EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public static extern int GET_GRAPH_SOUNDPRESSURE_PC([MarshalAsAttribute(UnmanagedType.AnsiBStr)]string fanDescription, ref string buffer);

        [DllImport(@"EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public static extern int GET_GRAPH_SOUNDPOWER_PC([MarshalAsAttribute(UnmanagedType.AnsiBStr)]string fanDescription, ref string buffer);

        [DllImport(@"EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public static extern int GET_GRAPH_RPM_PC([MarshalAsAttribute(UnmanagedType.AnsiBStr)]string fanDescription, ref string buffer);

        [DllImport(@"EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public static extern int GET_GRAPH_SOUND_PC([MarshalAsAttribute(UnmanagedType.AnsiBStr)]string fanDescription, ref string buffer);
        #endregion

        public Form1()
        {
            InitializeComponent();
        }
        #region btpfad_Click **************************************************
        private void btpfad_Click(object sender, EventArgs e)
        {
            string BuPath;                                                                                     // Declaration of the String BuPath // Deklaration des strings BuPath
            FolderBrowserDialog folderBrowserDialog1 = new FolderBrowserDialog();                              // Creation of the FolderBrowserDialog where you can choose the path // FolderBrowser wird erstellt, wo man den Pfad wählen kann
            if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)                                          // If you click "Ok" on the BrowserDialog // Wenn "Ok" auf dem FolderBrowserDialog geklickt wird
            {
                BuPath = folderBrowserDialog1.SelectedPath;                                                    // Save the path in the variable BuPath // Speichere den Pfad in die Variable BuPath
                DialogResult dialogResult = MessageBox.Show("Wollen sie den Pfad " + BuPath + " übernehmen?", "Pfad übernehmen?", MessageBoxButtons.YesNo); // Message Box appears which asks you whether you want to take the path // Benachrichtigung erscheint welche dich frägt, ob du den Pfad übernehmen möchtest 
                if (dialogResult == DialogResult.Yes)       // If yes is clicked // Wenn Ja gecklickt wurde
                {
                    tbPfad.Text = BuPath;                   // Textbox shows the Path // Die Textbox zeigt den Pfad an
                }
                else if (dialogResult == DialogResult.No)   // If no is clicked // Wenn Nein geklickt wurde
                {
                    MessageBox.Show("Die Verarbeitung wurde abgebrochen"); // Message appears with the content that the processing is stopped // Verarbeitung wird abgebrochen und über eine Benachrichtigung bekanntgegeben
                }
            }
        }
        #endregion
        #region btPATH_TO_DATABASE_Click***************************************
        private void btPATH_TO_DATABASE_Click(object sender, EventArgs e)
        {
            Int32 n = -1;                                                    // Deklaration of the variable n // Deklaration der Variable n
            string path = "";                                                    // Deklaration of the variable path // Deklaration der Variable path

            path = tbPfad.Text;                                             // Save the content of the Textbox(the path) in the varaible path // Speichere den Inhalt der Textbox(den Pfad) in die Variable path          

            n = setPath(path);                                              // Look after the path // Schaue nach dem Pfad

            if (Directory.Exists(path) == false)
            {
                MessageBox.Show("Pfad existiert nicht! Bitte wählen sie einen gültigen Pfad.");
            }
        }
        #endregion
        #region setPath *******************************************************
        private int setPath(string path)
        {
            Int32 n;                                   // Declaration of the variable n for the error code // Deklaration der Variable n für den Error Code
            Int32 l;                                   // Declaration of the variable l for the length of the path (the number of the used signs)     // Deklaration der Variable l für die Länge des Pfades (die Anzahl der verwendete Zeichen)


            if (File.Exists(path + @"\Data.sqlite"))   // If the File Data.sqlite exists in the path // Wenn die File Data.sqlite im Pfad existiert 
            {
                l = path.Length;                       // Get the lentgh of the string path and save it // die Länge des strings path wird gespeichert 


                if (path[l - 1] != (';'))              // If there is no semicolon at the end of the Path // Wenn am Ende des Pfades kein Semikolon steht
                {
                    path = path + (';');               // Write a semicolon for the function SET_XML_PATH_PC // Füge ein Semikolon hinzu für die Funktion SET_XML_PATH_PC
                    n = SET_XML_PATH_PC(path);         // Get the Error Code 0 = the database is available; -1 = the database isn´t available // Hole den Errorcode aus der Funktion 0 = Datenbank ist verfügbar -1 = Datanbank ist nicht verfügbar 
                    show_Results(n, path);             // Show the result // Zeige das Ergebnis
                }
            }
            n = -1;
            return n;
        }
        #endregion
        #region show_Results***************************************************
        public void show_Results(int n, string path)
        {
            int l;                                     // Declaration of the variable l for the length of the string // Deklaration der Variable l für die Länge des Strings
            l = path.Length;                           // Get the length and save it in the variable l // Hole die Länge und speichere sie in der variable l
            if (path[l - 1] == ';')                    // If the last sign in the string is a semicolon.. // Wenn das letze Zeichen im string Pfad ein Semikolon ist.. 
            {
                path = path.Remove(l - 1, 1);          //.. Delete it // ..Lösche es
                if (File.Exists(path + @"\Data.sqlite") == true)  // If the File Data.sqlite exists in the path // Wenn die File Data.sqlite im Pfad existiert  
                {
                    tbPfad.Text = path;                // Write the path in the textbox // schreibe den Pfad in die Textbox
                    tbErrorcode.Text = Convert.ToString(n); // show the Error Code
                }
                else                                   // If the File Data.sqlite doesn´t exist in the path // Wenn die File Data.sqlite nicht im Pfad existiert  
                {
                    tbErrorcode.Text = "-1";           // Write the errorcode -1 in the textbox (Database isn´t available)     
                    tbPfad.Text = "keine Datenbankk vorhanden!" + path + @"\Data.sqlite"; // The Textbox shows the message that the database is not available // Die Textbox zeigt die Nachricht, das die Datenbank nicht vorhanden ist
                }
            }
        }
        #endregion

        #region btGetProductsPC_Click******************************************
        private void btGetProductsPC_Click(object sender, EventArgs e)
        {
            List_Item('P');                             // List the Items (ID and Type) in the listbox and the groupboxes // Liste die Items(ID und Typ) der Listbox und der Groupboxen auf
        }
        #endregion
        #region List_Item******************************************************
        private void List_Item(char mode)
        {

            int n;                                                              // Declaration of the variable n for the number of products // Deklaration der Variable n für die Anzahl der Produkte    
            string fanStringChar = new string(new Char(), 4000);                // Declaration of the variable fanStringChar for the function GET_PRODUCTS_PC // Deklaration der Variable fanStringChar für die Funktion GET_PRODUCTS_PC

            GC.GetTotalMemory(false);                                           // Free the Memory // Leere den Speicher
            GC.GetTotalMemory(true);                                            // reserve Memory for the function // Reserviere Speicher für die Funktion 

            Clear_Display();                                                    // Delete the Information in the listbox and the comboboxes // Lösche die Informationen in der listbox und der Comboboxen

            n = GET_PRODUCTS_PC(ref fanStringChar);                             // Get the Products n = the number of Products // Hole die Produkte  n = Die anzahl der Produkte bzw Ventilatoren 
            if (n < 0)                                                          // If the number is negative (because u didn´t Set the Path).. // Wenn die Anzahl negativ ist (Weil der Pfad noch nicht gesetzt wurde)
            {
                MessageBox.Show("Der Pfad wurde noch nicht gesetzt!");          // Show a Message that the path wasn´t set // Zeige eine Benachrichtigung, dass der Pfad nicht gesetzt wurde
            }
            else
            {
                show_Results_2(n, fanStringChar);                            // Show the result in the list box and the Comboboxes // Zeige das Ergebnis in der Listbox und den Comboboxen           
            }
        }
        #endregion
        #region Clear_Display**************************************************
        private void Clear_Display()
        {
            lbInfo.Items.Clear();                                               // Delete the information in the listbox // Lösche die Informationen in der listbox
            comBoxIdNo.Items.Clear();                                           // Delete the Information (Product ID) in the Combobox // Lösche die Informationen (Product ID) in der Combobox
            comBoxTyp.Items.Clear();                                            // Delete the information (Type) in the Combobox // Lösche die Informationen (Typ) in der Combobox 
        }
        #endregion
        #region show_Results_2*************************************************
        private void show_Results_2(int n, string FanList) // Function with the parameters: n = number of products; FanList = All the Information(Product ID and Type) of the ventilators // Funktion mit den Parametern : n = Anzahl der Produkte; FanList =  Alle Informationen(Product ID und Typ) zu den Ventilatoren 
        {

            string[] Typen = new string[n + 1];                                 // Declaration of a string array for the types // Deklaration eines string Arrays für die Typen

            string[] IdNo = new string[n + 1];                                  // Declaration of a string array for the ID // Deklaration eines string Arrays für die ID

            int m;                                                              // Declaration of the variable m for the number of signs after a '|' // Deklaration der Variable m für die Anzahl der Zeichen nach einem '|'                                                              
            string temp = "";                                                   // Declaration of the variable temp for transporting the product information into the arrays // Deklaration der Variable temp um die Produktinformationen in die Arrays zu transportieren
            int j = 0;                                                          // Declaration of the variable j for the Index of the Arrays // Deklaration der Variable j für den Index der Arrays
            int k;                                                              // Declaration of the variable k for the index of the Array destination // Deklaration der Variable k für den Index des Arrays destination
            tbGetFan.Text = Convert.ToString(n);                                // Write in the second Errorcode textbox the number of ventilators // Schreibe in der zweiten Errorcode Textbox die Anzahl der Ventilatoren 

            char[] thecopy = new char[FanList.Length];                      // Declaration of the Array thecopy for copying the product information  // Deklaration des Arrays thecopy,um die Produktinformationen zu kopieren  

            FanList = FanList.Replace(';', '|');                            // Replace all semicolons in the string with '|' // Ersetze alle Semikolons in dem string durch '|'

            lbInfo.Items.Add("number of existing ventilators:" + Convert.ToString(n));  // Listbox shows the number of ventilators // Die Listbox zeigt die Anzahl der Ventilatoren an


            n = 1;                                                          // Set n = 1 for showing all products (if n = 0 one product is missing)// setze n auf "1" um alle Produkte zu zeigen (bei n = 0 würde eins fehlen)
            while (FanList.Length > 0)                                      // While the Length of the String is bigger than 0 .. // Während die Länge des Strings größer als 0 ist..
            {
                m = FanList.IndexOf('|');                                   // ..set the number of signs till a '|' was found // .. setze die Anzahl der Zeichen bis ein '|' gefunden wurde
                for (k = 0; k < 50; k++)                                    // .. delete the values in the array // .. lösche die Werte in dem Array
                {
                    thecopy[k] = '\0';
                }
                FanList.CopyTo(0, thecopy, 0, m);                           // copy the ID to the char Array and save it in the string temp // Kopiere die ID in das char Array und speichere es in dem string temp 
                while (true)
                {
                    if (thecopy[j] == '\0')
                    {
                        break;
                    }
                    else
                    {
                        temp = temp + thecopy[j];
                        j++;                                                // increment j as long as a '\0' sign appears // inkrementiere solange bis ein '\0' Zeichen erscheint 
                    }
                }
                IdNo[n] = temp;                                             // copy the ID to the string Array IdNo // kopiere die ID in das string Array IdNo
                FanList = FanList.Remove(0, m + 1);                         // delete the ID in the string .. the Length is reduced now // Lösche die ID in dem string .. die Länge ist nun reduziert                                                           
                temp = "";                                                  // delete the content of temp // Lösche den Inhalt von temp             
                j = 0;                                                      // set j to 0 to count from the beginning // setze j auf 0 um vom Anfang hochzuzählen
                m = FanList.IndexOf('|');                                   // set the number of signs till a '|' was found // .. setze die Anzahl der Zeichen bis ein '|' gefunden wurde
                for (k = 0; k < 50; k++)
                {
                    thecopy[k] = '\0';
                }
                FanList.CopyTo(0, thecopy, 0, m);                           //  Copy the Type to the char Array and save it in the string temp // Kopiere den Typ in das char Array und speichere es in dem string temp
                while (true)
                {
                    if (thecopy[j] == '\0')
                    {
                        break;
                    }
                    else
                    {
                        temp = temp + thecopy[j];
                        j++;                                               // Increment j as long as a '\0' sign appears // Inkrementiere solange bis ein '\0' Zeichen erscheint  
                    }
                }
                Typen[n] = temp;                                             // Copy the ID to the string Array IdNo // Kopiere die ID in das string Array IdNo
                FanList = FanList.Remove(0, m + 1);                          // Delete the ID in the string .. the Length is reduced now // Lösche die ID in dem string .. die Länge ist nun reduziert                                                           
                temp = "";                                                  // Delete the content of temp // Lösche den Inhalt von temp             
                j = 0;                                                      // Set j to 0 to count from the beginning // Setze j auf 0 um vom Anfang hochzuzählen


                lbInfo.Items.Add("No:  " + Convert.ToString(n) + "  " + IdNo[n] + "  " + Typen[n]); // Show the product information of one product in the listbox // Zeige die Produktinformation eines Produktes in der Listbox
                comBoxIdNo.Items.Add(IdNo[n]);                                                      // Show the ID of one product in the listbox // Zeige die ID eines Produktes in der Combobox                                                      
                comBoxTyp.Items.Add(Typen[n]);                                                      // Show the Type of one product in the listbox // Zeige den Typ eines Produktes in der Combobox 
                n++;                                                                                // increment n to show all products // inkrementiere n um alles Produkte anzuzeigen

            }
            comBoxIdNo.Text = IdNo[1];                                                              // Show the ID of the first product in the Combobox // Zeige die ID des ersten Produkts in der Combobox 
            comBoxTyp.Text = Typen[1];                                                              // Show the Type of the first product in the Combobox // Zeige den Typ des ersten Produkts in der Combobox
        }
        #endregion
        #region Events*********************************************************
        private void comboBoxIdNo_SelectedIndexChanged(object sender, EventArgs e)
        {
            //Changes automatically the value in the text box if the product ID combo box value is changed // Ändert automatisch den Wert in der Textbox, wenn der Wert der product ID combobox sich ändert
            //tbIdNo_1.Text = comBoxIdNo.SelectedItem.ToString();
            comBoxTyp.SelectedIndex = comBoxIdNo.SelectedIndex;
            lbInfo.SelectedIndex = comBoxIdNo.SelectedIndex + 1;
        }
   
       
        private void comboBoxType_SelectedIndexChanged(object sender, EventArgs e)
        {
            // Changes automatically the selected index of the listbox and the ID combo boxx if the value is changed // Ändert automatisch den ausgewählten Index der Listbox und der ID Combobox, wenn sich der Wert ändert 
            comBoxIdNo.SelectedIndex = comBoxTyp.SelectedIndex;
            lbInfo.SelectedIndex = comBoxTyp.SelectedIndex + 1;
        }
        
        private void listBoxProducts_SelectedIndexChanged(object sender, EventArgs e)
        {
            // Changes automatically the selected index of the type combo box and the ID combo box if the value is changed // Ändert automatisch den ausgewählten Index der type Combobox und der ID Combobox, wenn sich der Wert ändert
            if (lbInfo.SelectedIndex != 0 && lbInfo.SelectedIndex != 1)
            {
                comBoxIdNo.SelectedIndex = lbInfo.SelectedIndex - 1;
                comBoxTyp.SelectedIndex = lbInfo.SelectedIndex - 1;
            }
        }
       

        private void textBoxDensity_KeyPress(object sender, KeyPressEventArgs e)
        {
            //Isolates the pressable keyboard keys. Only the following keys will work // Isoliert die druckfähigen Tastatur Tasten. Nur die folgenden Tasten werden
            //_ in the density TextBox: //_in der density TextBox funktionieren
            //_ Numbers from 0 to 9 //_ Zahlen von 0 bis 9
            //_ Control keys like backspace, arrows... // _Kontroll Tasten wie die Rücktaste, Pfeiltasten...
            //_ Comma [,] and dot [.] for decimal separation // _ Komma [;] und Punkt [.] für die Dezimaltrennung
            if (!char.IsDigit(e.KeyChar) && !char.IsControl(e.KeyChar) && e.KeyChar != '.' && e.KeyChar != ',')
            {
                e.Handled = true;
            }
        }
        #endregion
        #region check_products_prerequisite************************************
        //Checks if the database is bound to avoid crashes while clicking on buttons
        private void check_products_prerequisite(string Mode)
        {
            //If a product is selected and database is bound, then proceed // Wenn ein Produkt gewählt wurde und die Datenbank eingebunden wurde, dann fahre fort 
            if (comBoxIdNo.Text != "" && tbErrorcode.Text == "0")
            {
                //Here you should add the functions you want to call in the appropriate order. // Hier solltest du die Funktionen, die du in der angemessenen Reihenfolge aufrufen möchtest, hinzufügen 
                
                check_density();    // Check the density // Überprüfe die Dichte
                clear_polynom_fields_this(); // Clear the polynom fields // Lösche die Polynom Felder
                list_item_Graph(Mode);  // Show the Items in a list // Zeige die Items in einer Liste
            }

            //If no product is selected, clear the polynom fields and throw a message // Wenn kein Produkt gewählt wurde, lösche die Polynom Felder und zeige eine Benachrichtigung
            else
            {
                clear_polynom_fields_all();

                StringBuilder sbMessageBox = new StringBuilder();
                sbMessageBox.Append("A prerequisite is not set! \n");
                sbMessageBox.Append("Please check if you've chosen a product! \n");
                MessageBox.Show(sbMessageBox.ToString(), "Prerequisite not set");
            }
        }
        #endregion
        #region check_density**************************************************
        private void check_density()
        {
            double density;

            if (textBoxDensity.Text != "")
            {
                //Without converting the textBoxDensity's String, you can't operate or compare density's value. // Ohne die Umwandlung des Strings der textBoxDensity kannst du den Wert der Dichte nicht vergleichen bzw arbeiten
                density = Convert.ToDouble(textBoxDensity.Text);
                //This is the range of density. If density is out of range // Dies ist die Reichweite der Dichte. Wenn sie sich außerhalb der Reichweite befindet, 
                //_ then it's not valid and a message occurs. // _ ist sie nicht gültig und es erscheint eine Nachricht
                if (density > 1.45 || density < 0.6)
                {
                    textBoxDensity.Text = "";
                    labelDensityErr.Text = "Density not valid!";

                    StringBuilder sbMessageBoxDensity = new StringBuilder();
                    sbMessageBoxDensity.Append("Density not valid! \n");
                    sbMessageBoxDensity.Append("Allowed values are from [0.6] to [1.45]. \n");
                    sbMessageBoxDensity.Append("For floating values please check if you've wrote ");
                    sbMessageBoxDensity.Append("a comma [,] or dot [.] according to your region!");
                    MessageBox.Show(sbMessageBoxDensity.ToString(), "Density not valid!");
                }
                else
                {
                    //No error text if density is ok. // Kein Error Text wenn die Dichte in Ordnung ist
                    labelDensityErr.Text = "";
                }
            }
        }
        #endregion
        #region clear_polynom_fields_this**************************************
        //Clears all text boxes corresponding to their called Button. // Löscht alle Textboxen die mit dem aufgerufenem Button übereinstimmen
        private void clear_polynom_fields_this()
        {
            //Clears the richTextBoxPolynom // Löscht die richTextBoxPolynom
            richTextBoxPolynom.Clear();
            //Clears each text box corresponding to its parent panel. // Löscht jede Text Box mit dem entsprechenden parent panel 
            //Corresponding to the appropriate clicked Button, every Control in the Button's parent Panel gets the alias text boxes. // Entsprechend des angeklickten Buttons, bekommt jede Kontrolle in dem Button vom parent Panel die alias Text Box

            foreach (TextBox textBoxes in clickedButtonGlobal.Parent.Controls.OfType<TextBox>())
            {
                //Clears the corresponding TextBox // Löscht die entsprechende Textbox
                textBoxes.Clear();
            }
        }
        #endregion
        #region list_item_Graph************************************************
        private void list_item_Graph(string Mode)
        {
            int errCodePolynom = 99;

            //Building up a string for transfer to DLL // Aufbau eines Strings für den transfer zur DLL
            System.String stringInputDataIntern =
                comBoxIdNo.Text + ";" + numericUpDown1.Value + ";" + textBoxDensity.Text + ";";
            //Preallocating an amount of unused chars // Vorbelegung einer Menge von ungenutzen Zeichen
            string buffer = new string(new Char(), 4000);

            //selects the mode to be used.  // Wählt den Modus, der benutzt werden soll
            //errCodePolynom is a received error code from the DLL. // errCodePolynom ist ein erhaltener Code von der DLL
            //stringInputDataIntern is the product ID. Its value will be // stringInputDataIntern ist die Prpdukt ID. Sein Wert wird
            //_ changed when getting it back from the DLL and // _ geändert wenn man es von der DLL zurückbekommt und
            //_ this value will be passed to the show_results_Graph function then. // _ dieser Wert wird dann an die show_result_Graph Funktion weitergegeben
            switch (Mode)
            {
                
                //PC-functions // PC Funktionen
                case "Pfa_PC":
                    errCodePolynom = GET_GRAPH_PFA_PC(stringInputDataIntern, ref buffer);
                    show_Results_Graph(buffer);
                    break;

                case "N_PC":
                    errCodePolynom = GET_GRAPH_N_PC(stringInputDataIntern, ref buffer);
                    show_Results_Graph(buffer);
                    break;

                case "Pt_PC":
                    errCodePolynom = GET_GRAPH_PT_PC(stringInputDataIntern, ref buffer);
                    show_Results_Graph(buffer);
                    break;

                case "Eta_PC":
                    errCodePolynom = GET_GRAPH_ETA_PC(stringInputDataIntern, ref buffer);
                    show_Results_Graph(buffer);
                    break;

                case "P1_PC":
                    errCodePolynom = GET_GRAPH_POWER_PC(stringInputDataIntern, ref buffer);
                    show_Results_Graph(buffer);
                    break;

                case "I_PC":
                    errCodePolynom = GET_GRAPH_I_PC(stringInputDataIntern, ref buffer);
                    show_Results_Graph(buffer);
                    break;

                case "Md_PC":
                    errCodePolynom = GET_GRAPH_MD_PC(stringInputDataIntern, ref buffer);
                    show_Results_Graph(buffer);
                    break;

                case "MEta_PC":
                    errCodePolynom = GET_GRAPH_META_PC(stringInputDataIntern, ref buffer);
                    show_Results_Graph(buffer);
                    break;

                case "LpA_PC":
                    errCodePolynom = GET_GRAPH_SOUNDPRESSURE_PC(stringInputDataIntern, ref buffer);
                    show_Results_Graph(buffer);
                    break;

                case "LwA_PC":
                    errCodePolynom = GET_GRAPH_SOUNDPOWER_PC(stringInputDataIntern, ref buffer);
                    show_Results_Graph(buffer);
                    break;

                case "RPM_PC":
                    errCodePolynom = GET_GRAPH_RPM_PC(stringInputDataIntern, ref buffer);
                    show_Results_Graph(buffer);
                    break;

                case "Sound_PC":
                    errCodePolynom = GET_GRAPH_SOUND_PC(stringInputDataIntern, ref buffer);
                    show_Results_Graph(buffer);
                    break;
            }
            //Shows the Polynom Error Code in a TextBox // Zeige den Polynom Error in einer Text Box
            textBox133.Text = Convert.ToString(errCodePolynom);
        }
        #endregion
        #region clear_polynom_fields_all***************************************
        //Clears all Polynom text boxes. // Lösche alle Polynom Text Boxen
        private void clear_polynom_fields_all()
        {
            //Clears the richTextBoxPolynom // lösche die richTextBoxPolynom
            richTextBoxPolynom.Clear();
            //Elects each panel to get its inferior (child) text boxes // Wählt jeden Panel um seine untergeordneten Text Boxen zu bekommen
            foreach (Panel panels in groupBox1.Controls.OfType<Panel>())
            {
                //Clears each text box corresponding to its parent panel // Löscht jede Text Box die dem Parent Panel entsprechen
                foreach (TextBox textBoxes in panels.Controls.OfType<TextBox>())
                {
                    textBoxes.Clear();
                }
            }
        }
        #endregion
        #region show_Results_Graph*********************************************
        private void show_Results_Graph(string inputDataIntern)
        {
            int exponentcount = 0;
            StringBuilder sbPolynoms = new StringBuilder();
            StringBuilder sbCalculation = new StringBuilder();

            //Clears richTextBoxPolynom before giving new output of polynom data // Löscht die richTextBoxPolynom, bevor der neue Output der Polynom Daten gegeben werden
            richTextBoxPolynom.Clear();

            //Splits inputDataIntern into an Array of String at each semicolon // teilt die inputDataIntern in einem String Array bei jedem Semikolon
            string[] result = inputDataIntern.Split(new Char[] { ';' });
            //block is the array's last correct value // block ist der letze korrekte wert des Arrays
            int block = result.Length - 2;

            //clickedButtonGlobal is an object which inherits attributes from the corresponding clicked button. // clickedButtonGlobal ist ein Objekt welches die Attribute vom entsprechendem Button erbt
       
            richTextBoxPolynom.Text += clickedButtonGlobal.Text + "\n";
            richTextBoxPolynom.Text += "-------------------------------------------" + "\n";

            //Initiate the calculation formula, starting with the corresponding text of the pressed button. // Initiiert das Kalkulation Formular mit dem entsprechendem Text des gedrückten Buttons
            
            sbCalculation.Append(clickedButtonGlobal.Text + "=");

            //Fills the Text Boxes corresponding to their button // Füllt die Text Boxen zu dem entsprechenden Button 
            foreach (TextBox textBoxes in clickedButtonGlobal.Parent.Controls.OfType<TextBox>())
            {
                //Prevents out of range errors // verhindert den out of range Error
                if (block >= 0)
                {
                    //Data output to the GUI // Data Output der GUI
                    //Converting the results which are copied to a temporary variable into double // wandelt die Ergebnisse, welche in einer temporären Variable kopiert wurden, in eine Fließkommazahl 
                    double tempdouble = Convert.ToDouble(result[block]);
                    //Formatting the converted double and return it back to array // Formatiert die verwandelte Fließkommazahl und gebt es an das Array zurück
                    result[block] = String.Format("{0:0.0000000E+00}", tempdouble);
                    //Fills every text box which is related to its parent panel // Füllt jede Text Box welche zu dem parent panel gehören
                    textBoxes.Text = result[block];
                    sbPolynoms.Append("V^");
                    sbCalculation.Append("(");
                    sbCalculation.Append(result[block]);
                    sbCalculation.Append("*");
                    sbCalculation.Append("V^");
                    sbCalculation.Append(exponentcount);
                    sbCalculation.Append(")+");
                    //Increments the counting variable for the exponent // Inkrementiert die Zählvariable für den Exponent
                    sbPolynoms.Append(exponentcount++);
                    sbPolynoms.Append(":\t");
                    //Appends the actual array position to the StringBuilder // Hängt die aktuelle Array Position zu dem String Builder an 
                    //_ and selects the previous array position for the next call // _ und wählt die vorherige Array Position für den nächsten Aufruf
                    sbPolynoms.Append(result[block--]);
                    richTextBoxPolynom.Text += sbPolynoms.ToString() + "\n";
                    //Clears sbPolynoms for the next loop // Löscht sbPolynoms für die nächste Schleife
                    sbPolynoms.Clear();
                }
            }
            //Writes the whole sbCalculation String to the richTextBoxPolynom. // Schreibt das ganze sbCalculation String in die  richTextBoxPolynom
            Convert.ToString(sbCalculation);
            if (sbCalculation[sbCalculation.Length - 1] == '+')
                sbCalculation.Remove(sbCalculation.Length - 1, 1);
            richTextBoxPolynom.Text += "\n" + sbCalculation.ToString();
        }
        #endregion
        #region Buttons (Polynom) *********************************************
        // The Buttons of the PC functions// Buttons der PC Funktionen 
        public void button13_Click(object sender, EventArgs e)
        {
            clickedButtonGlobal = (Button)sender;
            check_products_prerequisite("Pfa_PC");
        }

        private void button14_Click(object sender, EventArgs e)
        {
            clickedButtonGlobal = (Button)sender;
            check_products_prerequisite("N_PC");
        }

        private void button15_Click(object sender, EventArgs e)
        {
            clickedButtonGlobal = (Button)sender;
            check_products_prerequisite("Pt_PC");
        }

        private void button16_Click(object sender, EventArgs e)
        {
            clickedButtonGlobal = (Button)sender;
            check_products_prerequisite("Eta_PC");
        }

        private void button17_Click(object sender, EventArgs e)
        {
            clickedButtonGlobal = (Button)sender;
            check_products_prerequisite("P1_PC");
        }

        private void button18_Click(object sender, EventArgs e)
        {
            clickedButtonGlobal = (Button)sender;
            check_products_prerequisite("I_PC");
        }

        private void button19_Click(object sender, EventArgs e)
        {
            clickedButtonGlobal = (Button)sender;
            check_products_prerequisite("Md_PC");
        }

        private void button20_Click(object sender, EventArgs e)
        {
            clickedButtonGlobal = (Button)sender;
            check_products_prerequisite("MEta_PC");
        }

        private void button21_Click(object sender, EventArgs e)
        {
            clickedButtonGlobal = (Button)sender;
            check_products_prerequisite("LpA_PC");
        }

        private void button22_Click(object sender, EventArgs e)
        {
            clickedButtonGlobal = (Button)sender;
            check_products_prerequisite("LwA_PC");
        }

        private void button23_Click(object sender, EventArgs e)
        {
            clickedButtonGlobal = (Button)sender;
            check_products_prerequisite("RPM_PC");
        }

        private void button24_Click(object sender, EventArgs e)
        {
            clickedButtonGlobal = (Button)sender;
            check_products_prerequisite("Sound_PC");
        }
        #endregion

        private async void timer1_Tick(object sender, EventArgs e)
        {
             
            timer1.Enabled = false;
            String[] parms = Environment.GetCommandLineArgs();
            int n;

            try
            {
                string path = parms[1];
                tbPfad.Text = path;
                path = parms[1] + (';');
                n = SET_XML_PATH_PC(path);         // Get the Error Code 0 = the database is available; -1 = the database isn´t available // Hole den Errorcode aus der Funktion 0 = Datenbank ist verfügbar -1 = Datanbank ist nicht verfügbar 
                show_Results(n, path);             // Show the result // Zeige das Ergebnis


                await PutTaskDelay();
                List_Item('P');
                await PutTaskDelay();
                button13.PerformClick();
                await PutTaskDelay();
                button14.PerformClick();
                await PutTaskDelay();
                button15.PerformClick();
                await PutTaskDelay();
                button16.PerformClick();
                await PutTaskDelay();
                button17.PerformClick();
                await PutTaskDelay();
                button18.PerformClick();
                await PutTaskDelay();
                button19.PerformClick();
                await PutTaskDelay();
                button20.PerformClick();
                await PutTaskDelay();
                button21.PerformClick();
                await PutTaskDelay();
                button22.PerformClick();
                await PutTaskDelay();
                button23.PerformClick();
                await PutTaskDelay();
                button24.PerformClick();

               
            }
            catch (Exception ex)
            {
 
            }
        }

        async Task PutTaskDelay()
        {

            await Task.Delay(1000);
        }

    }
}
